##
## Author: Tim Desjardins
## rtunes@agwego.com
## Date: Dec. 16, 2005
## use at your own risk
##

import os
import cgi
import sys
import time
import thread
import pprint
import shutil
import signal
import os.path
import urlparse
import SocketServer
import BaseHTTPServer
import SimpleHTTPServer
from Cheetah.Template import Template
from stat import *
import xml.sax.saxutils
#from rTunesTwitter import Twitter
#from rTunesLastFm import LastFM

# force py2exe to includes this module which is used
# in compiled templates
import Cheetah.DummyTransaction

version = "rTunes-1.1-itunes-8.2.1.6"
version_brief = "1.1"
accepted_list = [ '/action', '/xmlhttp', '/settings' ]

try:
	port = int( os.getenv( "RTUNES_PORT", 4444 ) )
except:
	port = 4444

INDEX = os.getenv( 'RTUNES_INDEX', 'index.cheetah' )

INDEXES = {
	'' : INDEX,
	'iphone' : 'index.iphone.cheetah'
}

ARTWORK_IMAGE = os.path.join( os.getcwd(), 'htdocs', 'artwork.jpg' )
NO_ARTWORK_IMAGE = os.path.join( os.getcwd(), 'htdocs', 'NoImage.gif' )
USER_PLAYLIST = 2
SHOW_ARTWORK = True

iTunesPlatformObj = None

current_artwork = "none"
playlists = []
htdocs = 'htdocs'
playing = 'stop'
player_position = 0

action_map = {
	'play' : 'Play',
	'pause' : 'Pause',
	'stop' : 'Stop',
	'nexttrack' : 'NextTrack',
	'previoustrack' : 'PreviousTrack',
	'resume' : 'Resume',
	'rewind' : 'Rewind',
	'fastforward' : 'FastForward'
}

class rTunesServerRequestHandler( SimpleHTTPServer.SimpleHTTPRequestHandler ) :
	permitted_ext = [ '.gif', '.jpg', '.png', '.cheetah', '.html', '.ico', '.js', '.css' ]
	isiPhone = False

	def do_GET( self ) :
		global iTunesPlatformObj, current_artwork
		location = None
		iTunes = iTunesPlatformObj

		mobile = ''
		if self.headers[ 'User-Agent' ].find( 'iPhone' ) != -1 :
			mobile = 'iphone'
		#else :
		#	print "x", self.headers[ 'User-Agent' ]

		#print "   -- path ", str( self.path ), "   -- command ", str( self.command )
		( x1, x2, path, x3, queryString, x4 ) = urlparse.urlparse( self.path )
		#print x1, " X ", x2, " X ", x3," X ", x4, self.raw_requestline,

		if path == '/quit' :
			print >> sys.stderr, "Exiting..."
			iTunes.Stop()
			os._exit(0)

		if path in accepted_list and self.command == 'GET' :
			if queryString :
				qsl = dict( cgi.parse_qsl( queryString ) )
				self.iTunesAction( iTunes, qsl )
				location = self.getReferer( self.headers )
				( x1, x2, path, x3, queryString, x4 ) = urlparse.urlparse( location )

		( proot, ext ) = os.path.splitext( path )
		response_file = os.path.join( htdocs, os.path.basename( path ))

		if ext not in self.permitted_ext :
			ext = '.cheetah'
			if os.path.isfile( os.path.join( htdocs, '%s%s' % ( path[1:], ext ))) :
				response_file = os.path.join( htdocs, '%s%s' % ( path[1:], ext ))
			else :
				response_file = os.path.join( htdocs, INDEXES[ mobile ] )

		fin = file( response_file, 'rb' )
		fstat = os.stat( response_file )
		if ext in '.cheetah' :
			#print " . . . cheetah ", response_file, "   mime type ", self.guess_type( response_file )
			template = Template( file = response_file )

			template.CurrentTrack = iTunes.GetCurrentTrackDict()
			template.CurrentPlaylist = iTunes.GetCurrentPlaylist()
			template.SoundVolume = iTunes.GetSoundVolume()
			template.iTunes = iTunes
			template.mobile = mobile
			self.doArtwork(iTunes)
			try :
				iTunes.Update()
			except:
				pass

			template.Playlists = iTunes.GetPlaylists()
			template_string = unicode( template )
			try:
				self.emitHeader( 200, len( template_string ), self.guessType( response_file ), location )
				self.wfile.write( template_string )
				self.wfile.flush()
			except:
				#print "************* socket error"
				pass
		else :
			try:
				self.emitHeader( 200, fstat[ ST_SIZE ], self.guessType( response_file ), location )
				self.copyfile( fin, self.wfile )
				self.wfile.flush()
			except:
				#print "************ socket error" # this appears to be a bug in the python implementaiton on windows
				pass
		fin.close()

	def do_POST( self ) :
		global iTunesPlatformObj
		iTunes = iTunesPlatformObj

		( x1, x2, path, x3, queryString, x4 ) = urlparse.urlparse( self.path )
		#print "   -- path ", str( self.path ), "   -- command ", str( self.command )

		if path in accepted_list and self.command == 'POST' :
			if queryString :
				qsl = dict( cgi.parse_qsl( queryString ) )
				( responseString, mime_type ) = self.iTunesAction( iTunes, qsl )

				try:
					self.emitHeader( 200, len( responseString ), mime_type )
					self.wfile.write( responseString )
					self.wfile.flush()
				except:
					pass
					#print "socket error"

	def emitHeader( self, responseCode, length, mimeType, location = None ) :
		if location :
			self.send_response( 307 )
		else :
			self.send_response( responseCode )

		self.send_header( "Content-type", mimeType )
		self.send_header( "Content-Length", str( length ) )
		if location :
			self.send_header( "Location", location )
			
		self.end_headers()

	def iTunesAction( self, iTunes, qsl ) :
		#print " - - iTunesAction ", qsl
		if 'cmd' not in qsl :
			print "iTunesAction: illegal action no cmd = "
			return

		cmd = qsl[ 'cmd' ].lower().capitalize()
		del qsl[ 'cmd' ]

		if cmd in iTunes.simple_actions :
			action = getattr( iTunes, action_map[ cmd.lower() ] )
			if cmd.lower() == 'play' :
				playing = True
			if cmd.lower() == 'stop' or cmd.lower() == 'pause' :
				playing = False
			self.doArtwork( iTunes )
			action()

		cmd = cmd.lower()
		if cmd in iTunes.complex_actions :
			if cmd == 'volume' :
				self.setVolume( iTunes, qsl[ 'level' ] )
				return ( str( iTunes.GetSoundVolume() ), 'text/plain' )
			if cmd == 'playlist' :
				iTunes.SetPlaylist( qsl[ 'index' ] )
				self.doArtwork(iTunes)
			if cmd == 'current_track' :
				# XML is nasty in this instance, but it's the best way to send arbitrary character data back
				response_xml = u"""<?xml version="1.0" encoding="UTF-8" standalone="yes"?>\n<response>\n"""

				response_xml += ( '<artist>' + xml.sax.saxutils.escape( iTunes.GetCurrentTrackArtist( False ) ) + '</artist>\n' )
				response_xml += ( '<name>' + xml.sax.saxutils.escape( iTunes.GetCurrentTrackName( False ) ) + '</name>\n' )
				response_xml += ( '<album>' + xml.sax.saxutils.escape( iTunes.GetCurrentTrackAlbum( False ) ) + '</album>\n' )

				response_xml += ( '</response>\n' )
				self.doArtwork( iTunes )
				return ( response_xml.encode( 'utf8', 'replace'), 'text/xml' )
			if cmd == 'settings' :
				iTunes.Settings( qsl )

		return ( ' no response', 'text/plain' ) # we don't care about returning anything.

	def doArtwork( self, iTunes ) :
		global current_artwork, SHOW_ARTWORK

		if not SHOW_ARTWORK:
			return

		if iTunes.GetCurrentTrack() :
			if current_artwork != iTunes.GetArtworkID() :
				if iTunes.TrackHasArtwork():
					iTunes.SaveArtwork( ARTWORK_IMAGE )
					current_artwork = iTunes.GetArtworkID()
				else :
					self.noArtwork()
					current_artwork = "none"
		else :
			if current_artwork != "none" :
				self.noArtwork()
				current_artwork = "none"

	def noArtwork( self ) :
		try :
			shutil.copyfile( NO_ARTWORK_IMAGE, ARTWORK_IMAGE )
		except Exception, e :
			pass

	def guessType( self, response_file ) :
		( name, ext ) = os.path.splitext( response_file )
		if ext == '.cheetah' :
			return "text/html"

		return self.guess_type( response_file )

	def setVolume( self, iTunes, volume ) :
		if volume :
			try: volume = int( volume )
			except: return

			if volume >= 0 and volume <= 100 :
				iTunes.SetSoundVolume( volume )

	def setPlaylist( self, playlist_index ) :
		if playlist_index :	
			try: pindex = int( playlist_index )
			except: return

			( x, x, x, pl ) = playlists[ pindex ]
			pl.PlayFirstTrack()

	def address_string(self):
		"""Return the client address formatted for logging."""
		
		host, port = self.client_address[:2]
		return host

	def getReferer( self, headers ) :
		referer = headers.getfirstmatchingheader( 'referer' )
		if referer :
			return referer[0][8:].strip() # [8:] strip off the Referer:
		else :
			return ''

class ThreadedHTTPServer( SocketServer.ThreadingMixIn, BaseHTTPServer.HTTPServer ) :
	pass

def terminate(signal, param):
	"""Signal handler (internal)"""

	print "caught signal, preparing to exit: signal = ", signal
	sys.exit()

def run( HandlerClass = rTunesServerRequestHandler, ServerClass = ThreadedHTTPServer, protocol="HTTP/1.0" ) :
	global port
	server_address = ('', port)

	HandlerClass.protocol_version = protocol
	httpd = ServerClass(server_address, HandlerClass)

	sa = httpd.socket.getsockname()
	print "\nServing HTTP on", sa[0], "port", sa[1], "Default Index ", INDEX, "...\n"

	httpd.serve_forever()

if __name__ == "__main__" :
	if len( sys.argv ) > 1 and sys.argv[1] == '-v' :
		print version
		sys.exit(0)
	try :
		if os.name == 'nt' :
			from rTunesWindows import Windows

			iTunesPlatformObj = Windows()
			iTunesPlatformObj.SetPort( port )
			iTunesPlatformObj.SetVersion( version )

			#os_server_class = ThreadedHTTPServer
			os_server_class = BaseHTTPServer.HTTPServer
			#
			#	Setup signal handlers
			#
			signal.signal(signal.SIGBREAK, terminate)
			signal.signal(signal.SIGTERM, terminate)
			signal.signal(signal.SIGINT, terminate)
		elif os.name == 'mac' :
			from rTunesMacOSXAppscript import MacOSXAppscript

			iTunesPlatformObj = MacOSXAppscript()
			iTunesPlatformObj.SetPort( port )
			iTunesPlatformObj.SetVersion( version )

			os_server_class = BaseHTTPServer.HTTPServer
			SHOW_ARTWORK = True
			#
			#	Setup signal handlers
			#
			signal.signal(signal.SIGHUP, terminate)
			signal.signal(signal.SIGTERM, terminate)
			signal.signal(signal.SIGINT, terminate)
			signal.signal(signal.SIGQUIT, terminate)
		elif os.name == 'posix' :
			import platform

			uname = platform.uname()

			if uname[0] in [ 'Linux', ]:
				print >> sys.stderr, " Sorry your OS isn't implemented yet, grab the source and let me know if you get it working!"
				sys.exit( 3 )
			elif uname[0] in [ 'Darwin', ]:
				from rTunesMacOSXAppscript import MacOSXAppscript

				iTunesPlatformObj = MacOSXAppscript()
				iTunesPlatformObj.SetPort( port )
				iTunesPlatformObj.SetVersion( version )

				os_server_class = BaseHTTPServer.HTTPServer
				SHOW_ARTWORK = True
				#
				#	Setup signal handlers
				#
				signal.signal(signal.SIGHUP, terminate)
				signal.signal(signal.SIGTERM, terminate)
				signal.signal(signal.SIGINT, terminate)
				signal.signal(signal.SIGQUIT, terminate)
			else:
				print >> sys.stderr, " Sorry your OS isn't implemented yet, grab the source and let me know if you get it working!"
				sys.exit( 3 )
		else :
			print >> sys.stderr, " Sorry your OS isn't implemented yet, grab the source and let me know if you get it working!"
			sys.exit( 3 )
	except Exception, e :
		print >> sys.stderr, " There was an error initializing the iTunes connection, make sure iTunes is running and you don't have personal firewall running"
		print >> sys.stderr, e
		sys.exit( 2 )

	if not iTunesPlatformObj :
		print >> sys.stderr, " iTunes is not initialized "
		sys.exit( 1 )

	#iTunesPlatformObj.LoadSocialNetwork()

	# blank the image to start
	try :
		shutil.copyfile( NO_ARTWORK_IMAGE, ARTWORK_IMAGE )
	except Exception, e :
		pass
	
	run( HandlerClass = rTunesServerRequestHandler, ServerClass = os_server_class )


"""
iTunes Windows commands:
----------------
Authorize
BackTrack
CLSID
CanSetShuffle
CanSetSongRepeat
CheckVersion
ConvertFile
ConvertFile2
ConvertFiles
ConvertFiles2
ConvertTrack
ConvertTrack2
ConvertTracks
ConvertTracks2
CreateEQPreset
CreatePlaylist
CreatePlaylistInSource
FastForward
GetITObjectByID
GetPlayerButtonsState
GotoMusicStoreHomePage
NextTrack
OpenURL
Pause
Play
PlayFile
PlayPause
PlayerButtonClicked
PreviousTrack
Quit
Resume
Rewind
SetOptions
Stop
SubscribeToPodcast
UpdateIPod
UpdatePodcastFeeds
"""

"""
iTunes OSX commands:
----------------
_TalkTo__ensure_WMAvailable
_TalkTo__eventloop_initialized
__doc__
__getattr__
__init__
__module__
_argmap_add
_argmap_count
_argmap_duplicate
_argmap_make
_argmap_move
_argmap_play
_argmap_print_
_argmap_search
_argmap_set
_elemdict
_get
_moduleName
_propdict
_set
_signature
_start
activate
add
back_track
close
convert
count
delete
download
duplicate
eject
exists
fast_forward
get
make
move
newevent
next_track
open
open_location
pause
play
playpause
previous_track
print_
quit
refresh
resume
rewind
run
search
send
send_flags
send_priority
send_timeout
sendevent
set
start
stop
subscribe
target
target_signature
update
updateAllPodcasts
updatePodcast
"""
